/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 1
Date    : 16.02.2012
Author  : 
Company : 
Comments: 


Chip type           : ATtiny13
Clock frequency     : 4.800000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 16
*****************************************************/

#include <tiny13.h>

#include <delay.h>

#define ADC_VREF_TYPE 0x20

#define out PORTB.0
#define tmp PORTB.4

unsigned char i,volt;
unsigned char n;

void adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
delay_us(10);
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
volt=ADCH;
if(volt>200) n=3;
    else if(volt>120) n=2;
        else if(volt>20) n=1;
}


void main(void)
{
// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State5=T State4=T State3=T State2=T State1=0 State0=0 
PORTB=0x00;
DDRB=0x13;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 600.000 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x02;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// ADC initialization
// ADC Clock frequency: 600.000 kHz
// ADC Bandgap Voltage Reference: Off
// ADC Auto Trigger Source: None
// Only the 8 most significant bits of
// the AD conversion result are used
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
DIDR0&=0x03;
DIDR0|=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;

while (1)
      {
      adc(1);
      if(n==1)
        {
        for(i=0;i<58;i++)
            {
            if((i==5)|(i==35)) tmp=1;
            if((i==20)|(i==50)) tmp=0;
            out=1;
            delay_us(8333);
            out=0;
            delay_us(8333);
            };
        delay_us(41665);
        }
      else if(n==2)
        {
        for(i=0;i<58;i++)
            {
            if((i==5)|(i==35)) tmp=1;
            if((i==20)|(i==50)) tmp=0;
            out=1;
            delay_us(833);
            out=0;
            delay_us(833);
            };
        delay_us(4265);
        }
      else if(n==3)
        {
        for(i=0;i<58;i++)
            {
            if((i==5)|(i==35)) tmp=1;
            if((i==20)|(i==50)) tmp=0;
            out=1;
            delay_us(83);
            out=0;
            delay_us(83);
            };
        delay_us(415);
        };
      };
}
